/*
	Nindows Library

	COPYRIGHT (C) SEGA ENTERSRISES,LTD.
*/


#ifndef _NINDOWS_H_
#define _NINDOWS_H_

#ifdef __cplusplus
extern "C"{
#endif

#include <Ninja.h>

/*--------------------------------------*/
/*      System Information              */
/*--------------------------------------*/
#define NWD_SM_CXSIZEFRAME  2           /* THICKFRAMẼt[̕         */
#define NWD_SM_CYSIZEFRAME  2           /* THICKFRAMẼt[̍       */
#define NWD_SM_CXBORDER     1           /* VO{[_[̕             */
#define NWD_SM_CYBORDER     1           /* VO{[_[̍           */
#define NWD_SM_CXMINTRACK   32          /* ŏ̃EBhE̕             */
#define NWD_SM_CYMINTRACK   10          /* ŏ̃EBhE̍           */
#define NWD_SM_CYCAPTION    20          /* LvV̍               */
#define NWD_SM_SZCAPTION    16          /* LvV̍               */
#define NWD_SM_CXSHADOW     8           /* ê                     */
#define NWD_SM_CYSHADOW     8           /* ê                     */

/*--------------------------------------*/
/*      Window Style                    */
/*--------------------------------------*/
#define NWD_WS_CAPTION      0x00000001  /* LvV                 */
#define NWD_WS_THICKFRAME   0x00000002  /* t[                     */
#define NWD_WS_BORDER       0x00000004  /* EEBhE           */
#define NWD_WS_SHADING      0x00000008  /* VF[fBO               */
#define NWD_WS_CONTROL      0x00000010  /* N[Y{bNX             */
#define NWD_WS_OFFSET       0x00000020  /* eEBhEƂ̑΍Wgp   */
#define NWD_WS_SHADOW       0x00000040  /* etEBhE                 */
#define NWD_WS_INVISIBLE    0x00000080  /* `ȂEBhE               */
#define NWD_WS_NOMOVE       0x00000100  /* }EXł̈ړȂ           */

#define NWD_WS_CLOSEBOX     NWD_WS_CONTROL
#define NWD_WS_MAXIMIZEBOX  0x00000200  /* ő剻{bNX             */
#define NWD_WS_MINIMIZEBOX  0x00000400  /* ŏ{bNX             */

#define NWD_WS_SB_HORZ      0x00001000  /* XN[o[               */
#define NWD_WS_SB_VERT      0x00002000  /* XN[o[               */

#define NWD_WS_CLOSE        0x80000000  /* EBhEIv               */

/*--------------------------------------*/
/*      Window Class                    */
/*--------------------------------------*/
enum {
	NWD_WC_WIN,                         /* ʏ̃EBhE             */
	NWD_WC_BUTTON,                      /* {^                       */
	NWD_WC_SCRBAR,                      /* XN[o[               */
	NWD_WC_SCRWIN,                      /* XN[EBhE         */
	NWD_WC_EDITWIN,                     /* GfBbgEBhE         */
	NWD_WC_MENUWIN,                     /* j[EBhE           */

	NWD_WC_CTLBOX                       /* Rg[{bNX         */
};

/*--------------------------------------*/
/*      Button Status                   */
/*--------------------------------------*/
#define NWD_BS_DOWN         0x00000001      /* {^Ă         */
#define NWD_BS_INVOKED      0x00000100      /* {^̋@\Iꂽ     */
#define NWD_BS_GRAYED       0x00000002      /* IłȂ             */

/*--------------------------------------*/
/*      Mouse Status                    */
/*--------------------------------------*/
#define NWD_MS_MOVE         0x00010000      /* }EXړ             */

#define NWD_MS_BUTTON       0x000f          /* {^ꂽ             */
#define NWD_MS_LBUTTON      0x0001          /* {^Ă       */
#define NWD_MS_RBUTTON      0x0002          /* E{^Ă       */
#define NWD_MS_MBUTTON      0x0004          /* {^Ă       */

#define NWD_MS_BUTTONDOWN   0x00f0          /* {^Jꂽ           */
#define NWD_MS_LBUTTONDOWN  0x0010          /* {^NbNꂽ     */
#define NWD_MS_RBUTTONDOWN  0x0020          /* E{^NbNꂽ     */
#define NWD_MS_MBUTTONDOWN  0x0040          /* {^NbNꂽ     */
#define NWD_MS_BUTTONUP     0x0f00          /* {^Jꂽ           */
#define NWD_MS_LBUTTONUP    0x0100          /* {^Jꂽ         */
#define NWD_MS_RBUTTONUP    0x0200          /* E{^Jꂽ         */
#define NWD_MS_MBUTTONUP    0x0400          /* {^Jꂽ         */

#define NWD_MS_LBUTTONUP    0x0100          /* {^Jꂽ         */
#define NWD_MS_RBUTTONUP    0x0200          /* E{^Jꂽ         */
#define NWD_MS_MBUTTONUP    0x0400          /* {^Jꂽ         */

#define NWD_MS_CONTROL      0x1000          /* Rg[L[ꂽ   */
#define NWD_MS_SHIFT        0x2000          /* VtgL[ꂽ         */

/* }EXJ[\̌` */
#define NWD_MCS_DRAG        0x40000000      /* EBhEړł       */
#define NWD_MCS_RESIZE      0x20000000      /* EBhETCYύXł */
#define NWD_MCS_AREAMASK    0x0000ffff      /*                              */

#define NWD_MCS_AREAFRAMET      0x0001      /* EBhEt[̏       */
#define NWD_MCS_AREAFRAMELT     0x0002      /* EBhEt[̍     */
#define NWD_MCS_AREAFRAMEL      0x0003      /* EBhEt[̍       */
#define NWD_MCS_AREAFRAMELB     0x0004      /* EBhEt[̍     */
#define NWD_MCS_AREAFRAMEB      0x0005      /* EBhEt[̉       */
#define NWD_MCS_AREAFRAMERB     0x0006      /* EBhEt[̉E     */
#define NWD_MCS_AREAFRAMER      0x0007      /* EBhEt[̉E       */
#define NWD_MCS_AREAFRAMERT     0x0008      /* EBhEt[̉E     */
#define NWD_MCS_AREACLIENT      0x0009      /* EBhENCAg       */
#define NWD_MCS_AREACAPTION     0x000a      /* EBhELvV       */

/* XN[EBhẼtO */
#define NWD_ES_HORIZONTAL       0x00000001  /* XN[\       */
#define NWD_ES_VERTICAL         0x00000002  /* XN[\       */
#define NWD_ES_USECLIP          0x00010000  /* NbsO             */


/*--------------------------------------*/
/*      Message Type                    */
/*--------------------------------------*/
enum {
	NWD_MSG_NULL,                           /*                              */
	NWD_MSG_ALL,                            /*                              */
	NWD_MSG_CLICK,                          /*                              */
	NWD_MSG_LBUTTONDOWN,                    /*                              */
	NWD_MSG_FOCUS,                          /*                              */
	NWD_MSG_CLOSE                           /*                              */
};

/*--------------------------------------*/
/*      Data Type                       */
/*--------------------------------------*/
enum {
	NWD_DT_CHAR,                            /* tPoCg             */
	NWD_DT_SHORT,                           /* tQoCg             */
	NWD_DT_INT,                             /* tSoCg             */
	NWD_DT_LONG,                            /* tSoCg             */
	NWD_DT_FLOAT,                           /* RQrbg_       */
	NWD_DT_UCHAR,                           /* ȂPoCg             */
	NWD_DT_USHORT,                          /* ȂQoCg             */
	NWD_DT_UINT,                            /* ȂSoCg             */
	NWD_DT_ULONG                            /* ȂSoCg             */
};

/*--------------------------------------*/
/*      Menu Type                       */
/*--------------------------------------*/
#define NWD_MF_NULL       0x0000            /* j[^[~l[^         */
#define NWD_MF_NORMAL     0x0001            /* ʏ탁j[             */
#define NWD_MF_SEPARATOR  0x0002            /* Zp[^                   */
#define NWD_MF_POPUP      0x0004            /* Tuj[                 */
#define NWD_MF_CHECKED    0x8000            /* `FbN}[N           */
#define NWD_MF_GRAYED     0x0008            /* Is                     */

/*--------------------------------------*/
/*      Font Size                       */
/*--------------------------------------*/
#define NWD_FONTTYPE_SMALL  1               /*                              */
#define NWD_FONTTYPE_NORMAL 2               /*                              */
#define NWD_FONTTYPE_LARGE  3               /*                              */


/*--------------------------------------*/
/*      Nindows Utility Type            */
/*--------------------------------------*/
#define NWD_DEFWIN_SYSMENU     0            /*                          */
#define NWD_DEFWIN_NINJAINFO   1            /*                          */
#define NWD_DEFWIN_WINDOWINFO  2            /*                          */
#define NWD_DEFWIN_TEXCONTROL  3            /*                          */
#define NWD_DEFWIN_TEXVIEWER   4            /*                          */
#define NWD_DEFWIN_PERINFO     5            /*                          */
#define NWD_DEFWIN_DEBUG       6            /*                          */
#define NWD_DEFWIN_PERFORMANCE 7            /*                          */


/*--------------------------------------*/
/*      Basic Structure                 */
/*--------------------------------------*/
typedef struct _NWS_RGBA {
	Uint8 r;                                /* (0-255)                    */
	Uint8 g;                                /* (0-255)                    */
	Uint8 b;                                /* (0-255)                    */
	Uint8 a;                                /* x(0-255) 255:s     */
} NWS_RGBA;

typedef struct _NWS_RECT {
	Sint32 left;                            /* [                         */
	Sint32 top;                             /* [                         */
	Sint32 right;                           /* E[                         */
	Sint32 bottom;                          /* [                         */
} NWS_RECT;

typedef struct _NWS_RECTF {
	Float left;                             /* [                         */
	Float top;                              /* [                         */
	Float right;                            /* E[                         */
	Float bottom;                           /* [                         */
} NWS_RECTF;

typedef struct _NWS_POINT {
	Sint32 x, y;                            /* W                         */
} NWS_POINT;

typedef struct _NWS_MOUSE {
	NWS_POINT pt;                           /* ݂̍W                   */
	Sint32    dt;                           /* ݂̏                   */
	Sint32    cursor;                       /* ݂̃J[\           */
	NWS_POINT oldPt;                        /* ̂̍W                     */
	NWS_POINT mv;                           /* ړ                       */
	NWS_POINT dragPt;                       /* hbOJnn_             */
} NWS_MOUSE;

/*--------------------------------------*/
/*      Basic Macro                     */
/*--------------------------------------*/
#define nwSetRGBA(_d, _r, _g, _b, _a)	\
	((_d)->r = (_r), (_d)->g = (_g), (_d)->b = (_b), (_d)->a = (_a))

#define nwSetRect(a, b , c, d, e)	\
	((a)->left = (b), (a)->top = (c), (a)->right = (d), (a)->bottom = (e))

/*--------------------------------------*/
/*      Message Structure               */
/*--------------------------------------*/
typedef Bool (*NWF_MSGPROC)(Sint32 msg, Sint32 param1, Sint32 param2);

typedef struct _NWS_MSGHANDLE {
	Sint32      msg;                        /*                              */
	NWF_MSGPROC func;                       /*                              */
} NWS_MSGHANDLE;

/*--------------------------------------*/
/*      Data Structure                  */
/*--------------------------------------*/
typedef struct _NWS_DATA {
	void *dt;                               /* f[^|C^               */
	Sint32 type;                            /* f[^^Cv                 */
} NWS_DATA;


/*--------------------------------------*/
/*      Window Structure                */
/*--------------------------------------*/
typedef struct _NWS_WIN {
	Sint32 style;                           /* EBhEX^C           */
	Sint32 wClass;                          /* EBhẼNX           */
	char* caption;                          /* EBhELvV     */
	Sint32 font;                            /* tHg^Cv               */

	struct _NWS_WIN* parent;                /* ̐eEBhẼ|C^ */
	struct _NWS_WIN* child;                 /* ̎q(Pq)EBhE   */
	struct _NWS_WIN* before;                /* ZEBhẼ|C^     */
	struct _NWS_WIN* next;                  /* ZEBhẼ|C^     */

	Sint32 x, y;                            /* NCAg̍W           */
	Sint32 w, h;                            /* NCAg̕A       */
/*	Sint32 sx,sy;*/                         /* NCAg̃ItZbgʒu */

	NWS_RGBA col[4];                        /* EBhE̐F               */
	NWS_MSGHANDLE* msgHandle;               /* bZ[W̃nh         */
	void* menuTable;                        /* j[e[u             */

	void* userBuf;                          /* [U[pobt@           */
	void (*clientDraw)(struct _NWS_WIN *NWFUNC);
	                                        /* NCAg`R[obN */
	void (*execFunc)(struct _NWS_WIN *NWFUNC);
	                                        /* EBhEp֐|C^   */
	void (*destructor)(struct _NWS_WIN* NWFUNC);
	                                        /* EBhEjR[obN */
	Sint32 param1, param2;                  /* [U[pp[^         */
	struct _NWS_WIN* hClose;                /* N[Y{bNX̃nh   */
	struct _NWS_WIN* hMaximize;             /* ő剻{^̃nh       */
	struct _NWS_WIN* hMinimize;             /* ŏ{^̃nh       */
} NWS_WIN;

typedef NWS_WIN* NWHWND;
typedef void (*NWF_BUTTONFUNC)(NWHWND);




/*--------------------------------------*/
/*      Button Structure                */
/*--------------------------------------*/
typedef struct _NWS_BUTTON {
	NWS_WIN         base;                   /* {EChE               */
	NWF_BUTTONFUNC  func;                   /* ꂽɌĂяo֐     */
	Sint32          state;                  /* {^̏                 */
	Sint32          count;                  /* func ̎s܂ł̃EFCg    */
} NWS_BUTTON;

/*--------------------------------------*/
/*      ScrollBar Structure             */
/*--------------------------------------*/
typedef struct _NWS_SCRBAR {
	NWS_WIN base;                           /* {EChE               */
	Float pos;                              /* ݒl                       */
	Float min;                              /* ŏl                       */
	Float max;                              /* ől                       */
	Float lineMove;                         /* ړl                       */
	Float pageMove;                         /* ړl                       */
	NWS_DATA dt;                            /* f[^                       */
} NWS_SCRBAR;

typedef struct {
	char* caption;                          /* LvV                 */
	NWS_DATA data;                          /* ֘Af[^                   */
	Float min, max;                         /* f[^őlAŏl         */
	Float line, page;                       /* CړʁAy[Wړ   */
	Float pos;                              /* f[^l                 */
} NWS_SCROLLBARINFO;

typedef struct {
	Sint32 n;                               /* XN[o[             */
	Sint32 style;                           /* XN[o[X^C       */
	Sint16 x, y;                            /* W                         */
	Sint16 w, h;                            /* TCY                       */
	NWS_SCROLLBARINFO* info;                /* XN[o[           */
} NWS_SCROLLBARLIST;


/*--------------------------------------*/
/*      Scroll Window Structure         */
/*--------------------------------------*/
typedef struct _NWS_SCRWIN {
	NWS_WIN base;                           /* {EBhE               */
	Sint32 sx, sy;                          /* XN[|WV         */
	Sint32 flag;                            /* XN[\tO     */
	NWS_RECT clip;                          /* XN[\͈           */
} NWS_SCRWIN;

/*--------------------------------------*/
/*      Edit Window Structure           */
/*--------------------------------------*/
typedef struct _NWS_EDITLINE {
	struct _NWS_EDITLINE* before;           /* ÕCւ̃|C^       */
	struct _NWS_EDITLINE* next;             /* ̃Cւ̃|C^       */
	Sint8* buf;                             /* obt@|C^         */
	Sint32 len;                             /*                        */
} NWS_EDITLINE;

typedef struct _NWS_EDITWIN {
	NWS_SCRWIN base;                        /* {EBhE               */
	Sint32 maxLine;                         /* ős                     */
	NWS_EDITLINE* lineBuf;                  /* sobt@                   */
	Sint32 lineSum;                         /* ݂̊mۍs               */
	NWS_EDITLINE* startLine;                /* ŏ̍s                     */
	NWS_EDITLINE* curLine;                  /* ݂̍s                     */
} NWS_EDITWIN;

/*--------------------------------------*/
/*      Menu Handle                     */
/*--------------------------------------*/
typedef void (*NWF_MENUHANDLE)(NWHWND, Sint32 idx, Sint32 param);

/*--------------------------------------*/
/*      Menu Table Structure            */
/*--------------------------------------*/
typedef struct _NWS_MENUTABLE {
	Sint32         type;                    /* j[^Cv               */
	char*          title;                   /* j[^Cg             */
	NWF_MENUHANDLE func;                    /* R[obN֐             */
	Sint32         param;                   /* p[^                   */
} NWS_MENUTABLE;


/*--------------------------------------*/
/*      Menu Window Structure           */
/*--------------------------------------*/
typedef struct _NWS_MENUWIN {
	NWS_WIN       base;                     /* {EBhE               */
	Sint32        check;                    /* ݃`FbN̍         */
	NWS_MENUTABLE* menuTable;               /* j[e[u             */
} NWS_MENUWIN;


/*--------------------------------------*/
/*      Font Structure                  */
/*--------------------------------------*/
typedef struct _NWS_FONT {
	Sint32      baseChar;                   /* {                     */
	Sint32      w,  h;                      /* ̎TCY               */
	Sint32      u, v;                       /* uvTCY               */
	Sint32      gw, gh;                     /* Obh̃TCY             */
	Sint32      dw;                         /* eNX`̉         */
	NJS_TEXNAME* texname;                   /* eNX`               */
	Uint32      globalIndex;                /* O[oCfbNX       */
} NWS_FONT;


/*--------------------------------------*/
/*      Prototypes                      */
/*--------------------------------------*/

/****************************************/
/*      System                          */
/****************************************/
#ifdef __SET4__
void nwInitSystem(Uint32 numTextures, Uint32 port);
#else
void nwInitSystem(Uint32 numTextures);
#endif
Sint32 nwExecute(void);
void nwExitSystem(void);
void nwInitResource(void);
Uint32 nwVersion(void);
void nwEnablePeripheral(Bool flag);
Float nwGetZ(void);
Float nwAddZ(void);

/****************************************/
/*      Menu                            */
/****************************************/
NWHWND nwCreateMenuWindow(NWS_MENUTABLE* menuTbl, const char* caption,
            Sint32 x, Sint32 y, NWHWND parent);

/****************************************/
/*      Font                            */
/****************************************/
void nwTextOut(NWHWND hWnd, Sint32 x, Sint32 y, const char* fmt, ...);
void nwSetTextColor(NWS_RGBA* col);
Sint32 nwGetFontSize(Sint32* width, Sint32* height);
void nwSelectSystemFont(Sint32 fonttype);

/****************************************/
/*      Button                          */
/****************************************/

NWHWND nwCreateButton(NWF_BUTTONFUNC func, const char* title,
	Sint32 x, Sint32 y, Sint32 w, Sint32 h, NWHWND parent);
void nwEnableButton(NWHWND hWnd, Bool flag);

/****************************************/
/*      Scroll Bar                      */
/****************************************/
NWHWND nwCreateScrollBar(Sint32 type, const char* title,
	Sint32 x, Sint32 y, Sint32 w, Sint32 h, NWHWND parent);
void nwSetScrollBarPos(NWHWND hWnd, Float pos);
void nwSetScrollBarRange(NWHWND hWnd, Float min, Float max);
void nwSetScrollBarData(NWHWND hWnd, NWS_DATA *dt);
void nwSetScrollBarLineMove(NWHWND hWnd, Float step);
void nwSetScrollBarPageMove(NWHWND hWnd, Float step);
void nwCreateScrollBarArray(NWS_SCROLLBARLIST* list, NWHWND parent);

/****************************************/
/*      Scroll Window                   */
/****************************************/
Bool nwScrWinEnableScroll(NWHWND hWnd, Sint32 flag);
Bool nwScrWinSetClip(NWHWND hWNd, NWS_RECT* rect);
Bool nwScrWinScroll(NWHWND hWnd, Sint32 x, Sint32 y);
Bool nwScrWinGetScroll(NWHWND hWnd, Sint32* x, Sint32* y);

/****************************************/
/*      Edit Window                     */
/****************************************/
NWHWND nwCreateEditWindow(Sint32 lineSum, const char* caption, Sint32 style,
	Sint32 x, Sint32 y, Sint32 w, Sint32 h, NWHWND parent);
Bool nwEditWinAddString(NWHWND hWnd, const char* string);
Bool nwEditWinPrintf(NWHWND hWnd, const char* fmt, ...);

/****************************************/
/*      Window Management               */
/****************************************/
NWHWND nwCreateWindow(Sint32 wClass, const char* caption, Sint32 style,
	Sint32 x, Sint32 y, Sint32 w, Sint32 h, NWHWND parent);
void nwDestroyWindow(NWHWND hWnd);

void nwBringWindowToTop(NWHWND hWnd);
NWHWND nwFindWindow(NWHWND hWnd, const char* name);
NWHWND nwFindWindowByPos(Sint16 x, Sint16 y);
NWHWND nwFindWindowEx(NWHWND hWnd, const char* name);

void nwGetClientRect(NWHWND hWnd, NWS_RECT* rc);
Bool nwGetWindowColor(NWHWND hWnd, NWS_RGBA* col);
Bool nwGetWindowPos(NWHWND hWnd, Sint32* x, Sint32* y);
void nwGetWindowRect(NWHWND hWnd, NWS_RECT* rc);
Bool nwGetWindowSize(NWHWND hWnd, Sint32* w, Sint32* h);
Bool nwGetWindowStyle(NWHWND hWnd, Sint32* style);
Sint32 nwGetWindowText(NWHWND hWnd, char *buf, Sint32 size);

Bool nwSetWindowColor(NWHWND hWnd, NWS_RGBA* col);
Bool nwSetWindowStyle(NWHWND hWnd, Sint32 and_style, Sint32 or_style);
Bool nwSetWindowPos(NWHWND hWnd, Sint32 x, Sint32 y);
Bool nwSetWindowSize(NWHWND hWnd, Sint32 w, Sint32 h);
Bool nwSetWindowText(NWHWND hWnd, const char* text);


/****************************************/
/*      Common Dialog                   */
/****************************************/
NWHWND nwCreateColorDialog(Sint32 x, Sint32 y, NWS_RGBA* rgba, NWHWND parent);
NWHWND nwCreatePropertyDialog(NWHWND hWnd, Sint32 x, Sint32 y);

/****************************************/
/*      Nindows Utility                 */
/****************************************/
void nwDebugPrintf(Sint8 *fmt, ...);
void nwSetDefWindowColor(Sint32 win, NWS_RGBA* col);
void nwSetDefWindowStyle(Sint32 win, Sint32 and_style, Sint32 or_style);
void nwSetDefWindowPos(Sint32 win, Sint32 x, Sint32 y);
void nwSetDefWindowSize(Sint32 win, Sint32 w, Sint32 h);
void nwSetUserMenu(NWS_MENUTABLE* menu);

/****************************************/
/*      Mouse                           */
/****************************************/
void nwGetMousePosition(Sint32* x, Sint32* y);


#ifdef __cplusplus
}
#endif

#endif /* _NINDOWS_H_ */
