/*
 * sg_syCbl.h
 *
 * FUNCTION: check a video cable with a machine.
 * MODIFICATION:
 *  0.51 Modified for BootROM 0.70 by SEKI Masahiro
 */
#ifndef _SG_CBL_H_
#define _SG_CBL_H_

#if 1 /* 19980928 */
typedef enum SYE_CBL_CABLE_TAG {
	SYE_CBL_CABLE_VGA = 0,
	SYE_CBL_CABLE_RESERVED = 1,
	SYE_CBL_CABLE_NTSC_RGB = 2,
	SYE_CBL_CABLE_PAL_RGB = 2,
	SYE_CBL_CABLE_RGB = 2,
	SYE_CBL_CABLE_NTSC = 3,
	SYE_CBL_CABLE_PAL = 3,
	SYE_CBL_CABLE_VBS = 3
} SYE_CBL_CABLE;
#else
typedef enum SYE_CBL_CABLE_TAG {
	SYE_CBL_CABLE_VGA = 0,
	SYE_CBL_CABLE_NTSC = 1,
	SYE_CBL_CABLE_PAL = 1,
	SYE_CBL_CABLE_VBS = 1,
	SYE_CBL_CABLE_NTSC_RGB = 2,
	SYE_CBL_CABLE_PAL_RGB = 2,
	SYE_CBL_CABLE_RGB = 2,
	SYE_CBL_CABLE_RESERVED = 3
} SYE_CBL_CABLE;
#endif

SYE_CBL_CABLE syCblCheckCable( void );

#endif
