
/************************************************************
  Ninja Sample
  COPYRIGHT (C) SEGA ENTERPRISES, LTD.

  ^Cg F `uP[uڑ`FbNB
  ҏW F 98-08-21 Jn
************************************************************/

#include <shinobi.h>
#include <sg_sycbl.h>
#include <njdef.h>

#define TEXNUM 1
#define MAX_VERTEXES 1000

void main(void)
{
	njSetBorderColor( 0x00000000 );
    njUserInit();
    while (njUserMain() == NJD_USER_CONTINUE) {
        njWaitVSync();
    }
    njUserExit();
}

/* 摜[h̃Xe[^Xm */
Sint32 VideoMode;

/************************************************************
  [U[֐̃vg^Cv錾
************************************************************/
void StartDisplayCable( void );
void CableChack( void );

/************************************************************
  
************************************************************/
void njUserInit(void)
{
    /*VXe*/
	StartDisplayCable();
    /*obNOEhJ[ݒ*/
    njSetBackColor(ARGB(0, 150, 0, 0), ARGB(0, 150, 0, 0), ARGB(0, 0, 0, 0));
    /*_f[^o^pobt@AP[g*/
    njInitVertexBuffer(MAX_VERTEXES * 64 / 4, 0, MAX_VERTEXES * 64 / 4, 0, 0);
	njInitPrint( NULL, 0, NJD_TEXFMT_ARGB_1555 );
    /* fobO̐F */
    njPrintColor(ARGB(255, 150, 150, 150));
}

/************************************************************
  s郁C
************************************************************/
Sint32 njUserMain(void)
{
    /* `uP[ȕԂmF */
	CableChack();
    /*Tv̕\*/
    njPrintC(NJM_LOCATION(6, 5), "Ninja Sample AV CABLE CHECK");

    /*Xe[^X̕\*/
    if(VideoMode == NJD_RESOLUTION_640x480_NTSCNI){
		njPrintC(NJM_LOCATION(2, 7), "NJD_RESOLUTION_640x480_NTSCNI");
    }
    /*Xe[^X̕\*/
    if(VideoMode == NJD_RESOLUTION_VGA){
	    njPrintC(NJM_LOCATION(2, 7), "NJD_RESOLUTION_VGA");
	}
	
    return NJD_USER_CONTINUE;
}

/************************************************************
  sIɌĂяoI
************************************************************/
void njUserExit(void)
{
    sbExitSystem();
}
/************************************************************
  ɂ`uP[u̎ނmF鏈
************************************************************/
void StartDisplayCable( void )
{
  SYE_CBL_CABLE Cable;
  Cable = syCblCheckCable();
  switch( Cable ) {
	case SYE_CBL_CABLE_VGA:
		sbInitSystem(NJD_RESOLUTION_VGA, NJD_FRAMEBUFFER_MODE_RGB565, 1);
	    /* Xe[^Xɕۑ */
		VideoMode = NJD_RESOLUTION_VGA;
    break;
	case SYE_CBL_CABLE_NTSC:
	    sbInitSystem(NJD_RESOLUTION_640x480_NTSCNI, NJD_FRAMEBUFFER_MODE_RGB565, 1);
	    /* Xe[^Xɕۑ */
		VideoMode = NJD_RESOLUTION_640x480_NTSCNI;
    break;
   }
}


/************************************************************
  `uP[u̕ύX`FbN鏈
************************************************************/

void CableChack( void )
{
  SYE_CBL_CABLE MainCable;
  MainCable = syCblCheckCable();
  if((MainCable == SYE_CBL_CABLE_VGA) && (VideoMode == NJD_RESOLUTION_640x480_NTSCNI)){
    /* \~߂ */
    njStopDisplay();
	/* eNX`̑SJ */
   	njReleaseTextureAll();
    /* 𑜓x̕ύX */
   	njChangeSystem(NJD_RESOLUTION_VGA, NJD_FRAMEBUFFER_MODE_RGB565, 1);
    /*_f[^o^pobt@AP[g*/
    njInitVertexBuffer(MAX_VERTEXES * 64 / 4, 0, MAX_VERTEXES * 64 / 4, 0, 0);
	njInitPrint( NULL, 0, NJD_TEXFMT_ARGB_1555 );
    /* Xe[^Xɕۑ */
	VideoMode = NJD_RESOLUTION_VGA;
  }

  if((MainCable == SYE_CBL_CABLE_NTSC) && (VideoMode == NJD_RESOLUTION_VGA)){
   /* \~߂ */
    njStopDisplay();
	/* eNX`̑SJ */
   	njReleaseTextureAll();
    /* 𑜓x̕ύX */
   	njChangeSystem(NJD_RESOLUTION_640x480_NTSCNI, NJD_FRAMEBUFFER_MODE_RGB565, 1);
    /*_f[^o^pobt@AP[g*/
    njInitVertexBuffer(MAX_VERTEXES * 64 / 4, 0, MAX_VERTEXES * 64 / 4, 0, 0);
	njInitPrint( NULL, 0, NJD_TEXFMT_ARGB_1555 );
    /* Xe[^Xɕۑ */
	VideoMode = NJD_RESOLUTION_640x480_NTSCNI;
  }
}
