/*
    Ninja Sample

    COPYRIGHT (C) SEGA ENTERSRISES,LTD.

    F40 Sample for SET5

    1998.7.23
*/
#include <Shinobi.h>
#include <Nindows.h>

#define OBJECT  object_f40_gte_sh_null1_1_null1_1
#define TEXLIST texlist_f40_gte_sh_null1_1

extern  NJS_CNK_OBJECT  OBJECT[];
extern NJS_TEXLIST TEXLIST[];

/* eNX`̐ݒ */
NJS_TEXMEMLIST  tex[100];

extern NJS_MATRIX   matrix[32];
extern NJS_VERTEX_BUF   vbuf[4096];

NJS_VIEW    view;
NJS_LIGHT   light;

Sint32  xx = 0,yy = 0,zz = 0;

void njUserInit(void)
{
    /*
        njInitSystem̕ςsbInitSystemsB
        ڂ́Asbinit.c

    */
    njSetBorderColor( 0 ) ;
    sbInitSystem( NJD_RESOLUTION_640x480_NTSCI, NJD_FRAMEBUFFER_MODE_RGB565, 1 );
    /*
        eNX`̃[Nobt@mۂB܂łF40̃eNX`ōő
        TCY1024x128MIPMAPȂ̃[hłTCY0x40800oCgm
        Ă0x800ȏ0x800Pʂ̎wŃ[hł悤ɕύX܂B
        őTCYق[h͑
    */
    njInitTextureBuffer((Sint8*)vbuf,0x800*100);

    njInitVertexBuffer( 900000, 0, 200000, 0 ,0);
    njInitPrint(NULL,0,0);

    njInitMatrix( matrix, 32 , 0);
    njInit3D( vbuf, 4096 );
    njInitView( &view );

	njCnkSetSimpleLight( 0.f, 0.f, 1.0f );
	njCnkSetSimpleLightIntensity( 1.0f, 0.5f );

    njSetView( &view );

    njInitTexture( tex,100);

    /*
        NINDOWS SET4Ƀ|[gݒ肷

    */
    nwInitSystem(100,NJD_PORT_A0);

    /*
        eNX`DG WorkShop̃JgfBNg
        uĂ


    */
    njLoadTexture( TEXLIST );
    njSetTexture( TEXLIST );

    njControl3D( NJD_CONTROL_3D_CONSTANT_ATTR|NJD_CONTROL_3D_NO_CLIP_CHECK );
    njSetConstantAttr( 0xffffffff, NJD_FILTER_BILINEAR);

    njClipZ( -2.0f, -100.f );
    njSetAspect( 1.0f, 1.0f );

    njSetBackColor(0x00000000,0x00000000,0x000000FF);
    njPrintSize(16);
}

Sint32 njUserMain(void)
{
    njClearMatrix();
    njTranslate( NULL, 1.f, 0.f, -7.f );
    njRotateXYZ( NULL, xx,yy,zz );
    njCnkSimpleDrawObject(OBJECT);

    njPrintC(NJM_LOCATION(2,3),"TEST SET5 .. F40");

    yy += 173;
    xx = -6000;

    return nwExecute();

}

void njUserExit(void)
{
    nwExitSystem();
    njExitPrint();
    njExitTexture();
    sbExitSystem();
}

