/********************************************************************
 *  Shinobi Library
 *  Copyright (c) 1998 SEGA
 *
 *  Library : High layer Configuration Library
 *  Module  : Library Interface Header
 *  File    : sg_sycfg.h
 *  Date    : 1998-09-28
 *  Version : 1.00
 *
 ********************************************************************/

#ifndef _SG_SYCFG_H_
#define _SG_SYCFG_H_

/********************************************************************/
/*  CN[ht@C                                            */
/********************************************************************/
#include    <sg_xpt.h>                      /*                      */
#include    <shinobi.h>                     /*                      */
#include    <sg_cfg.h>                      /*                      */
/********************************************************************/
/*  萔`                                                        */
/********************************************************************/
#define SYD_CFG_STEREO  (0x00)              /* XeIݒ         */
#define SYD_CFG_MONO    (0x01)              /* mݒ         */
#define SYD_CFG_OK      (SYD_BT_CFG_OK)     /* I             */
#define SYD_CFG_NG      (SYD_BT_CFG_ERR)    /* ُI             */

/********************************************************************/
/*  ^`                                                          */
/********************************************************************/

/********************************************************************/
/*  Lϐ`                                                    */
/********************************************************************/

/********************************************************************/
/*  ֐`                                                        */
/********************************************************************/
#ifdef __cplusplus
extern "C"{                                 /* for C++ Interface    */
#endif  /* __cplusplus */

Sint32 syCfgInit( Void* ) ;                 /* Cu */
Sint32 syCfgExit( Void  ) ;                 /* CuI   */
Sint32 syCfgSetSoundMode( Sint32  ) ;       /* ݒ̍XV       */
Sint32 syCfgGetSoundMode( Sint32* ) ;       /* ݒ̎Q       */

#ifdef __cplusplus
}                                           /* for C++ Interface    */
#endif /* __cplusplus  */
#endif /* _SG_SYCFG_H_ */
/****************************************** End of sg_sycfg.h *******/
