/********************************************************************/
/*                                                                  */
/*  Shinobi Fiber Library Header(sg_syfbr.h)                        */
/*                                                                  */
/*  98/02/06 r0.00                                                  */
/*  98/05/04 r0.04 ʎq̖̓                                 */
/*  98/05/04 r0.05 t@Coe[u[U擾             */
/********************************************************************/

#ifndef _SG_SYFBR_H_
#define _SG_SYFBR_H_

/********************************************************************/
/*  CN[ht@C                                            */
/********************************************************************/
#include    <sg_xpt.h>                      /*                      */
#include    <sg_ov.h>                       /*                      */

/********************************************************************/
/*  萔`                                                        */
/********************************************************************/
#ifdef SYD_FBR_FIXEDTBL                                               /* r0.05 */
#define SYD_FBR_MAXFIBER    (32)             /* t@Cȍl    */
#endif                                                                /* r0.05 */
#define SYD_FBR_MINFIBER    (2)              /* t@Cỏl    *//* r0.05 */

#define SYD_FBR_NULL        (NULL)           /* t@ConhG[l*//* r0.07 */
#define SYD_FBR_OK          (0)              /* t@Co֐߂l  *//* r0.07 */
#define SYD_FBR_NG          (-1)             /* t@Co֐߂l  *//* r0.07 */

#define SYD_FBR_NOTSETED        (-1)
#define SYD_FBR_THREADTOCREATE  (-1)
#define SYD_FBR_NOTEXISTFIBER   (-1)         /* t@Co       */
                                             /* t@Conhl */
#define SYD_FBR_SYSSTACKSIZE (292)           /* VXeKvƂX^bN */

#define SYD_FBR_LID {   \
    0x77b9fee0,         \
    0xe397,0x11d1,      \
    0x9a,0xb0,0x00,0xa0,\
    0x24,0xd8,0x60,0x79 \
} ;

/********************************************************************/
/*  ^`                                                          */
/********************************************************************/
typedef struct SyFbrS_INFO_tag{             /* t@Co         */
    void*       sp ;                        /* t@CõX^bN|C^ */
    void*       data ;                      /* t@Cõf[^     */
} SYS_FBR_INFO; 
typedef SYS_FBR_INFO*    SYFBR ;
typedef void (*SyFbrYfunc)(void*) ;         /* t@Co֐^       */

#define SYD_FBR_FBRSIZE (sizeof(SYS_FBR_INFO))

/********************************************************************/
/*  Lϐ`                                                    */
/********************************************************************/
#ifdef  SYD_FBR_FIXEDTBL                    /*                      *//* r0.05 */
extern SYS_FBR_INFO sygFbrTbl[] ;           /* t@Coe[u     */
#else                                       /*                      *//* r0.05 */
extern SYS_FBR_INFO* sygFbrTblPtr ;         /*                      *//* r0.05 */
#endif                                      /*                      *//* r0.05 */
extern Sint32      sygFbrMaxFiber ;         /* őt@Co       *//* r0.05 */
extern SYFBR       sygFbrCurrent ;          /* ݂̃t@Co       */

extern const UUID sygFbrLID ;               /* Cuhc       *//* r0.06 */

/********************************************************************/
/*  ֐`                                                        */
/********************************************************************/

#ifdef __cplusplus
extern "C"{                                 /* for C++ Interface    */
#endif  /* __cplusplus */

#ifdef SYD_FBR_FIXEDTBL                                              /* r0.05 */
extern  Sint32  syFbrInit( void ) ;
#else                                                                /* r0.05 */
extern  Sint32  syFbrInit( void*, Sint32) ;                          /* r0.05 */
#endif                                                               /* r0.05 */

extern  SYFBR   syFbrCreateFiber( void*,Uint32,SyFbrYfunc,void* ) ;
extern  SYFBR   syFbrConvertThreadToFiber( void* ) ;
extern  Sint32  syFbrDeleteFiber    ( SYFBR ) ;
extern  SYFBR   syFbrGetCurrentFiber( void ) ;
extern  void*   syFbrGetFiberData   ( void ) ;

extern  void*   syFbrCreateFiberMain(void*,long,SyFbrYfunc,void* ) ;
extern  void    syFbrSwitchToFiber        ( SYFBR ) ;
extern  void    syFbrSwitchToFiber2       ( SYFBR ) ;
extern  void    syFbrDelayedSwitchToFiber ( SYFBR ) ;
extern  void    syFbrDelayedSwitchToFiber2( SYFBR ) ;

extern  void*   syFbrGetSp  (SYFBR) ;
extern  void*   syFbrGetData(SYFBR) ;
extern  void    syFbrSetSp  (SYFBR,void*) ;
extern  void    syFbrSetData(SYFBR,void*) ;

extern  SYS_FBR_INFO*   syFbrGetTblPtr( int n ) ;                    /* r0.05 */
extern  Sint32  syFbrGetMaxFiber( void ) ;                           /* r0.05 */
extern  void*   syFbrGet_fib_sp ( int i) ;

#if 0
extern  void*   get_fib_data(int i) ;
extern  void    set_fib_sp  (int i, void* sp) ;
extern  void    set_fib_data(int i, void* data) ;
#endif

extern  void    syFbrDumpTable( void ) ;

#ifdef __cplusplus
}                                           /* for C++ Interface    */
#endif /* __cpulspuls  */
#endif /* __SG_FB_H__ */
/********************************************* End of fiber.h *******/
