/*
 *  Middleware Library
 *  Copyright (c) 1998 SEGA
 *  
 *		Middleware Play
 *
 *  Module  : Library Header File
 *  File    : WAV_MW.H
 *  Create  : 1998-09-01
 *  Modify  : 1998-10-14
 *  Version : 1.01
 *  Note    :
 */

#ifndef	_WAV_MW_H_
#define	_WAV_MW_H_

/*
 *		Middleware library function for Wave Decoder
 */

/***********************************************************************
 *      CN[ht@C
 ***********************************************************************/

/***********************************************************************
 *      萔}N
 ***********************************************************************/

/*	Wave-Decoder Error	*/
#define	MWD_PLY_ERR_WAV_INIT	(-301)			/*	Initialize Error		*/
#define	MWD_PLY_ERR_WAV_NOTYPE	(-302)			/*							*/
#define	MWD_PLY_ERR_WAV_ERRFN	(-303)			/*							*/
#define	MWD_PLY_ERR_WAV_FINISH	(-304)			/*	Finish Error			*/
#define	MWD_PLY_ERR_WAV_CREATE	(-305)			/*	Handle Create Error		*/
#define	MWD_PLY_ERR_WAV_DSTRY	(-306)			/*	Handle Destroy Error	*/
#define	MWD_PLY_ERR_WAV_START	(-307)			/*	Decode Start Error		*/
#define	MWD_PLY_ERR_WAV_STOP	(-308)			/*	Decode Stop Error		*/

/*	AudioRenderer Error	*/
#define	MWD_PLY_ERR_RNA_INIT	(-401)
#define	MWD_PLY_ERR_RNA_FINISH	(-402)
#define	MWD_PLY_ERR_RNA_CREATE	(-403)
#define	MWD_PLY_ERR_RNA_DSTRY	(-404)
#define	MWD_PLY_ERR_RNA_START	(-405)
#define	MWD_PLY_ERR_RNA_STOP	(-406)
#define	MWD_PLY_ERR_RNA_PRM		(-407)

/*	GSC Handle Max		*/
#define	MWD_GSCHN_MAX			(1)

#define	MWD_PLY_AT_EXEC_VSYNC	(0)
#define	MWD_PLY_MN_EXEC_VSYNC	(1)

/***********************************************************************
 *      񋓒萔
 ***********************************************************************/

/***********************************************************************
 *      }N
 ***********************************************************************/
#define	MWD_PLY_ALLOC_SJBUF(n)		((2048*(n))+32)
/*	ŏobt@TCY					*/
#define	MWD_PLY_ALLOC_LIMIT			(48)

/***********************************************************************
 *      f[^^̐錾
 ***********************************************************************/
typedef struct {
	Uint8	*buf;
	Sint32	size;
} MWS_PLY_CPRM_WAV;

/***********************************************************************
 *		ϐ̐錾
 ***********************************************************************/

/***********************************************************************
 *      ֐̐錾
 ***********************************************************************/

/*	Initialize Wave-Decode Library		*/
void	mwPlyInitWav(Sint32 mode);

/*	Finish using Wave-Decode Library	*/
void	mwPlyFinishWav(void);

/*	Create MWPLY handle for Wave-Deocde	*/
MWPLY	mwPlyCreateWav(MWS_PLY_CPRM_WAV *cprm);

#endif	/*	_WAV_MW_H_	*/
